Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCSampleConfigFile.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCSampleConfigFile.cpp	(revision 747)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCSampleConfigFile.cpp	(revision 751)
@@ -102,7 +102,7 @@
 }
 
-bool SampleConfigFile::getEntityClustersMergedClusters()
-{
-	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Merged Clusters"));
+bool SampleConfigFile::getEntityClustersGroupedClusters()
+{
+	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Grouped Clusters"));
 }
 
@@ -132,4 +132,14 @@
 }
 
+Ogre::String SampleConfigFile::getBillboardCloudIndirectPointMeshName()
+{
+	return getSetting("Billboard Cloud Indirect Point Mesh Name");
+}
+
+Ogre::String SampleConfigFile::getBillboardCloudIndirectPointMaterialName()
+{
+	return getSetting("Billboard Cloud Indirect Point Material Name");
+}
+
 Ogre::String SampleConfigFile::getEntityClustersFolder()
 {
@@ -137,7 +147,7 @@
 }
 
-Ogre::String SampleConfigFile::getEntityClustersMergedMeshName()
-{
-	return getSetting("Entity Clusters Merged Mesh Name");
+Ogre::String SampleConfigFile::getEntityClustersGroupedMeshName()
+{
+	return getSetting("Entity Clusters Grouped Mesh Name");
 }
 
@@ -147,7 +157,7 @@
 }
 
-Ogre::String SampleConfigFile::getEntityClustersMergedMaterialName()
-{
-	return getSetting("Entity Clusters Merged Material Name");
+Ogre::String SampleConfigFile::getEntityClustersGroupedMaterialName()
+{
+	return getSetting("Entity Clusters Grouped Material Name");
 }
 
@@ -192,4 +202,14 @@
 }
 
+Ogre::String SampleConfigFile::getEntityClustersGroupedTextureUnit0Name()
+{
+	return getSetting("Entity Clusters Grouped Texture Unit 0 Name");
+}
+
+Ogre::String SampleConfigFile::getEntityClustersSplittedTextureUnit0Name()
+{
+	return getSetting("Entity Clusters Splitted Texture Unit 0 Name");
+}
+
 Ogre::String SampleConfigFile::getBillboardCloudMergedTextureUnit0Name()
 {
@@ -207,7 +227,7 @@
 }
 
-Ogre::String SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasName()
-{
-	return getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Name");
+Ogre::String SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasName()
+{
+	return getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Name");
 }
 
@@ -217,7 +237,7 @@
 }
 
-unsigned int SampleConfigFile::getBillboardCloudDiffuseColorBillboardGroupTextureSize()
-{
-	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Billboard Group Texture Size"));
+unsigned int SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureSize()
+{
+	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Size"));
 }
 
@@ -227,32 +247,57 @@
 }
 
-unsigned int SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasBitRange()
-{
-	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Bit Range"));
-}
-
-unsigned int SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasSize()
-{
-	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Size"));
-}
-
-unsigned int SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureSize()
-{
-	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Billboard Group Texture Size"));
-}
-
-unsigned int SampleConfigFile::getBillboardCloudDiffuseColorBillboardGroupTextureAtlasSize()
-{
-	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Billboard Group Texture Atlas Size"));
-}
-
-bool SampleConfigFile::getBillboardCloudDiffuseColorBillboardGroupTextureAtlasGeneration()
-{
-	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Billboard Group Texture Atlas Generation"));
-}
-
-bool SampleConfigFile::getBillboardCloudIndirectBillboardGroupTextureAtlasGeneration()
-{
-	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Billboard Group Texture Atlas Generation"));
+unsigned int SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasBitRange()
+{
+	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Bit Range"));
+}
+
+unsigned int SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasBitRange()
+{
+	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Bit Range"));
+}
+
+unsigned int SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasSize()
+{
+	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Size"));
+}
+
+unsigned int SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureSize()
+{
+	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Size"));
+}
+
+unsigned int SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasSize()
+{
+	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Size"));
+}
+
+bool SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasDebug()
+{
+	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Debug"));
+}
+
+bool SampleConfigFile::getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasDebug()
+{
+	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Debug"));
+}
+
+bool SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasDebug()
+{
+	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Debug"));
+}
+
+bool SampleConfigFile::getBillboardCloudIndirectMergedBillboardsTextureAtlasDebug()
+{
+	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Merged Billboards Texture Atlas Debug"));
+}
+
+bool SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasGeneration()
+{
+	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Generation"));
+}
+
+bool SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasGeneration()
+{
+	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Generation"));
 }
 
@@ -272,4 +317,9 @@
 }
 
+Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasName()
+{
+	return getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Name");
+}
+
 Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasName()
 {
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCSubEntity.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCSubEntity.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCSubEntity.cpp	(revision 751)
@@ -167,21 +167,4 @@
 	return &mUniqueVertexList;
 }
-
-/*
-void SubEntity::createUniqueVertices()
-{
-	for (unsigned int i = 0; i < getNumVertices(); i++)
-	{
-		UniqueVertex uniqueVertex;
-		uniqueVertex.position = getVertex(i);
-		uniqueVertex.normal = getNormal(i);
-		for (unsigned int j = 0; j < getNumTexCoordSets(); j++)
-		{
-			uniqueVertex.uv[j] = getTexCoord(j,i);
-		}
-		
-	}
-}
-*/
 
 void SubEntity::addUniqueVertex(UniqueVertex uniqueVertex)
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardClusterData.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardClusterData.cpp	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardClusterData.cpp	(revision 751)
@@ -6,4 +6,5 @@
 BillboardClusterData::BillboardClusterData(): references(0) // initialize references to 0 
 {
+
 }
 
@@ -134,7 +135,7 @@
 }
 
-void BillboardClusterData::addBillboardUVMapMin(Ogre::Vector2 min)
+void BillboardClusterData::addBillboardUVMapMin(Ogre::Vector2 minVec)
 {
-	mGroupedBillboardUVMapMinList.push_back(min);
+	mGroupedBillboardUVMapMinList.push_back(minVec);
 }
 
@@ -149,7 +150,7 @@
 }
 
-void BillboardClusterData::addBillboardUVMapMax(Ogre::Vector2 max)
+void BillboardClusterData::addBillboardUVMapMax(Ogre::Vector2 maxVec)
 {
-	mGroupedBillboardUVMapMaxList.push_back(max);
+	mGroupedBillboardUVMapMaxList.push_back(maxVec);
 }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCKMeansClusterSerializer.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCKMeansClusterSerializer.cpp	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCKMeansClusterSerializer.cpp	(revision 751)
@@ -17,8 +17,7 @@
 	unsigned int numBillboardGroups = Ogre::StringConverter::parseInt(billboardGroupsNode->ToElement()->Attribute("count"));
 	
-	for (unsigned int iBillboardGroup = 0; iBillboardGroup < numBillboardGroups; iBillboardGroup++)
+	unsigned int iBillboardGroup = 0;
+	for (TiXmlNode *billboardGroupNode = billboardGroupsNode->FirstChild("billboardGroup"); billboardGroupNode; billboardGroupNode = billboardGroupNode->NextSibling() )
 	{
-		TiXmlNode *billboardGroupNode = billboardGroupsNode->FirstChild("billboardGroup");
-
 		unsigned int numBillboards = Ogre::StringConverter::parseInt(billboardGroupNode->ToElement()->Attribute("count"));
 
@@ -49,4 +48,5 @@
 			}
 		}
+		iBillboardGroup++;
 	}
 }
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCManager.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCManager.cpp	(revision 747)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCManager.cpp	(revision 751)
@@ -138,7 +138,7 @@
 		mOgreMeshSerializer->setEntity(entity);
 		mOgreMeshSerializer->exportMesh(mSampleConfigFile->getEntityClustersFolder() +
-			mSampleConfigFile->getEntityClustersMergedMeshName(), false, false);
-		
-		OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh((Ogre::Mesh*)entity->getMesh().get(), mSampleConfigFile->getEntityDistributionFolder() + mSampleConfigFile->getEntityClustersMergedMeshName());
+			mSampleConfigFile->getEntityClustersGroupedMeshName(), false, false);
+		
+		OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh((Ogre::Mesh*)entity->getMesh().get(), mSampleConfigFile->getEntityDistributionFolder() + mSampleConfigFile->getEntityClustersGroupedMeshName());
 		//OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(entity->getMesh(), mSampleConfigFile->getEntityClustersFolder() + mSampleConfigFile->getEntitiesMeshPrefixName() + "Merged.mesh" + ".xml");				
 	}
@@ -205,5 +205,5 @@
 	{
 		BBC::SubEntityPtr subEntity = mLeaves->getBillboardCloud()->getEntity()->getSubEntity(iSubEntity);
-		subEntity->setMaterialName(mSampleConfigFile->getBillboardCloudGroupedMaterialName());
+		subEntity->setMaterialName(mSampleConfigFile->getBillboardCloudGroupedMaterialName() + Ogre::StringConverter::toString(iSubEntity));
 	}
 	mOgreMeshSerializer->setEntity(mLeaves->getBillboardCloud()->getEntity());
@@ -233,5 +233,5 @@
 
 	OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh(mLeaves->getBillboardCloud()->getEntity()->getMesh()->get(), mSampleConfigFile->getBillboardCloudFolder() + mSampleConfigFile->getBillboardCloudSplittedMeshName());
-	OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(mLeaves->getBillboardCloud()->getEntity()->getMesh()->get(), mSampleConfigFile->getBillboardCloudFolder() + mSampleConfigFile->getBillboardCloudSplittedMeshName() + ".xml");
+	//OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(mLeaves->getBillboardCloud()->getEntity()->getMesh()->get(), mSampleConfigFile->getBillboardCloudFolder() + mSampleConfigFile->getBillboardCloudSplittedMeshName() + ".xml");
 }
 
@@ -241,5 +241,5 @@
 	{
 		BBC::SubEntityPtr subEntity = mLeaves->getBillboardCloud()->getEntity()->getSubEntity(iSubEntity);
-		subEntity->setMaterialName(mSampleConfigFile->getBillboardCloudGroupedMaterialName());
+		subEntity->setMaterialName(mSampleConfigFile->getBillboardCloudMergedMaterialName());
 	}
 	mOgreMeshSerializer->setEntity(mLeaves->getBillboardCloud()->getEntity());
@@ -346,5 +346,5 @@
 	numSerializedBillboards = 0;
 
-	if (mSampleConfigFile->getEntityClustersMergedClusters())
+	if (mSampleConfigFile->getEntityClustersGroupedClusters())
 	{
 		BBC::EntityPtr entity;
@@ -359,5 +359,5 @@
 			{			
 				BBC::EntityPtr entityClusterized = entityCluster->getEntity();
-				entityClusterized->getSubEntity(0)->setMaterialName(mSampleConfigFile->getEntityClustersMergedMaterialName());
+				entityClusterized->getSubEntity(0)->setMaterialName(mSampleConfigFile->getEntityClustersGroupedMaterialName());
 				BBC::SubEntityPtr subEntity = entityClusterized->getSubEntity(0);
 
@@ -383,7 +383,7 @@
 		mOgreMeshSerializer->setEntity(entity);
 		mOgreMeshSerializer->exportMesh(mSampleConfigFile->getEntityClustersFolder() +
-			mSampleConfigFile->getEntityClustersMergedMeshName(), false, false);
-		
-		OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh(entity->getMesh()->get(), mSampleConfigFile->getEntityClustersFolder() + mSampleConfigFile->getEntityClustersMergedMeshName());
+			mSampleConfigFile->getEntityClustersGroupedMeshName(), false, false);
+		
+		OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh(entity->getMesh()->get(), mSampleConfigFile->getEntityClustersFolder() + mSampleConfigFile->getEntityClustersGroupedMeshName());
 		//OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(entity->getMesh(), mSampleConfigFile->getEntityClustersFolder() + mSampleConfigFile->getEntityClustersMeshPrefixName() + "Merged.mesh" + ".xml");
 	}
@@ -408,5 +408,5 @@
 		mSampleConfigFile->getEntitySampleMeshName(), false, false);
 	OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh(entityLeaf->getMesh()->get(), mSampleConfigFile->getEntityDistributionFolder() + mSampleConfigFile->getEntitySampleMeshName());
-	OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(entityLeaf->getMesh()->get(), mSampleConfigFile->getEntityDistributionFolder() + mSampleConfigFile->getEntitySampleMeshName() + ".xml");	
+	//OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(entityLeaf->getMesh()->get(), mSampleConfigFile->getEntityDistributionFolder() + mSampleConfigFile->getEntitySampleMeshName() + ".xml");	
 }
 
@@ -419,5 +419,4 @@
 void LBBCManager::generateBillboardCloud()
 {
-
 	if (mSampleConfigFile->getBillboardCloudGroupedBillboards())
 	{				
@@ -425,19 +424,16 @@
 		mLeaves->getBillboardCloud()->initializeBillboardCloudGroups(mSampleConfigFile->getBillboardCloudGroups());
 		
-		if (mSampleConfigFile->getBillboardCloudDiffuseColorBillboardGroupTextureAtlasGeneration())
-		{
-			mBillboardCloudUVMapper->shutdown();
-			mBillboardCloudUVMapper->setBillboardCloud(mLeaves->getBillboardCloud());
-			mBillboardCloudUVMapper->setTextureWidth(mSampleConfigFile->getBillboardCloudDiffuseColorBillboardGroupTextureSize());
-			mBillboardCloudUVMapper->setTextureHeight(mSampleConfigFile->getBillboardCloudDiffuseColorBillboardGroupTextureSize());
-			mBillboardCloudUVMapper->setTextureAtlasWidth(mSampleConfigFile->getBillboardCloudDiffuseColorBillboardGroupTextureAtlasSize());
-			mBillboardCloudUVMapper->setTextureAtlasHeight(mSampleConfigFile->getBillboardCloudDiffuseColorBillboardGroupTextureAtlasSize());
-			mBillboardCloudUVMapper->initialize();			
-			mBillboardCloudUVMapper->generateTextureAtlasTextureCoords(false, mSampleConfigFile->getBillboardCloudGroupedBillboards(), mSampleConfigFile->getBillboardCloudGroups()); 
-			
-			mLeaves->getBillboardCloud()->generateBillboardCloudGroups();
-			//saveBillboardCloudGrouped();
-			//saveBillboardCloudGroupedXML();
-		}
+		mBillboardCloudUVMapper->shutdown();
+		mBillboardCloudUVMapper->setBillboardCloud(mLeaves->getBillboardCloud());
+		mBillboardCloudUVMapper->setTextureWidth(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureSize());
+		mBillboardCloudUVMapper->setTextureHeight(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureSize());
+		mBillboardCloudUVMapper->setTextureAtlasWidth(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasSize());
+		mBillboardCloudUVMapper->setTextureAtlasHeight(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasSize());
+		mBillboardCloudUVMapper->initialize();			
+		mBillboardCloudUVMapper->generateTextureAtlasTextureCoords(false, mSampleConfigFile->getBillboardCloudGroupedBillboards(), mSampleConfigFile->getBillboardCloudGroups()); 
+		
+		mLeaves->getBillboardCloud()->generateBillboardCloudGroups();
+		saveBillboardCloudGrouped();
+		saveBillboardCloudGroupedXML();		
 	}
 
@@ -448,19 +444,16 @@
 		mLeaves->getBillboardCloud()->initializeBillboardCloudGroups(1);
 
-		if (mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasGeneration())
-		{
-			mBillboardCloudUVMapper->shutdown();
-			mBillboardCloudUVMapper->setBillboardCloud(mLeaves->getBillboardCloud());
-			mBillboardCloudUVMapper->setTextureWidth(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureSize());
-			mBillboardCloudUVMapper->setTextureHeight(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureSize());
-			mBillboardCloudUVMapper->setTextureAtlasWidth(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize());
-			mBillboardCloudUVMapper->setTextureAtlasHeight(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize());
-			mBillboardCloudUVMapper->initialize();
-			mBillboardCloudUVMapper->generateTextureAtlasTextureCoords(false, mSampleConfigFile->getBillboardCloudGroupedBillboards(), 1); 
-
-			mLeaves->getBillboardCloud()->generateBillboardCloudGroups();
-			saveBillboardCloudMerged();
-			saveBillboardCloudMergedXML();
-		}
+		mBillboardCloudUVMapper->shutdown();
+		mBillboardCloudUVMapper->setBillboardCloud(mLeaves->getBillboardCloud());
+		mBillboardCloudUVMapper->setTextureWidth(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureSize());
+		mBillboardCloudUVMapper->setTextureHeight(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureSize());
+		mBillboardCloudUVMapper->setTextureAtlasWidth(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize());
+		mBillboardCloudUVMapper->setTextureAtlasHeight(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize());
+		mBillboardCloudUVMapper->initialize();
+		mBillboardCloudUVMapper->generateTextureAtlasTextureCoords(false, mSampleConfigFile->getBillboardCloudGroupedBillboards(), 1); 
+
+		mLeaves->getBillboardCloud()->generateBillboardCloudGroups();
+		saveBillboardCloudMerged();
+		saveBillboardCloudMergedXML();
 	}
 
@@ -482,4 +475,72 @@
 		saveBillboardCloudXML();
 	}
+
+	saveBillboardCloudIndirectSplittedPointMeshName();
+}
+
+void LBBCManager::saveBillboardCloudIndirectSplittedPointMeshName()
+{
+	BBC::EntityPtr entity;
+	unsigned int numSubEntities = 0;
+
+	entity = BBC::EntityPtr(new BBC::Entity());
+	entity->removeSubEntity(0);
+	
+	for (unsigned int iBillboard = 0; iBillboard < getLeaves()->getBillboardCloud()->getNumBillboards(); iBillboard++)
+	{
+		BBC::BillboardPtr billboard = getLeaves()->getBillboardCloud()->getBillboard(iBillboard);		
+		BBC::EntityClusterPtr entityCluster = billboard->getBillboardClusterData()->getEntityCluster();
+
+		if (entityCluster->getNumEntitiesClusterData() > 0)
+		{					
+			entity->createSubEntity();
+			entity->getSubEntity(numSubEntities)->setMaterialName(mSampleConfigFile->getBillboardCloudIndirectPointMaterialName());
+			entity->getSubEntity(numSubEntities)->enableNormals(false);
+			entity->getSubEntity(numSubEntities)->enableTextureCoords(false);
+			entity->getSubEntity(numSubEntities)->enableVertexColours(true);
+
+			for (unsigned int iLeaf = 0; iLeaf < entityCluster->getNumEntitiesClusterData(); iLeaf++)
+			{
+				BBC::UniqueVertex vertex;
+
+				LeafKMeansClusterData *leafKMeansClusterData = (LeafKMeansClusterData*)entityCluster->getEntityClusterData(iLeaf).get();
+				Leaf *leaf = (Leaf*)leafKMeansClusterData->getEntity().get();
+				vertex.position = leaf->getPosition();
+				vertex.colour = Ogre::ColourValue(Ogre::Math::RangeRandom(0.0, 1.0), Ogre::Math::RangeRandom(0.0, 1.0), Ogre::Math::RangeRandom(0.0, 1.0), 1.0).getAsRGBA(); 
+				entity->getSubEntity(numSubEntities)->addUniqueVertex(vertex);
+			}
+
+			unsigned int iVertexFace = 0;
+			Ogre::Vector3 faceVertexIndices = Ogre::Vector3::ZERO;
+
+			for (unsigned int iVertex = 0; iVertex < entity->getSubEntity(numSubEntities)->getNumVertices(); iVertex++)
+			{
+				faceVertexIndices[iVertexFace] = iVertex;
+				iVertexFace++;
+				
+				if ((iVertex + 1) != entity->getSubEntity(numSubEntities)->getNumVertices())
+				{
+					if (iVertexFace == 3)
+					{
+						entity->getSubEntity(numSubEntities)->addFaceVerticesIDs(faceVertexIndices);
+						iVertexFace = 0;
+						faceVertexIndices = Ogre::Vector3::ZERO;
+					}
+				}
+				else
+				{
+					entity->getSubEntity(numSubEntities)->addFaceVerticesIDs(faceVertexIndices);
+				}				
+			}
+
+			numSubEntities++;
+		}
+	}
+	
+	mOgreMeshSerializer->setEntity(entity);
+	mOgreMeshSerializer->exportMesh(mSampleConfigFile->getBillboardCloudFolder() + mSampleConfigFile->getBillboardCloudIndirectPointMeshName(), false, false);
+	OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh(entity->getMesh()->get(), mSampleConfigFile->getEntityDistributionFolder() + mSampleConfigFile->getBillboardCloudIndirectPointMeshName());
+	OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(entity->getMesh()->get(), mSampleConfigFile->getEntityDistributionFolder() + mSampleConfigFile->getBillboardCloudIndirectPointMeshName() + ".xml");	
+
 }
 
